
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;



public class ServerMonitor{

	/**
	 * The main-method which runs the servermonitor
	 * @param args
	 */
	public static void main(String[] args) {
		String host = "localhost";
		String port = "1099";
		String service = "simulation";
		int sleeptime = 10000;
		
			for (int i=0; i<args.length; i++) 
			{
				if (args[i].equals("--host")) 
				{
					if (i+1<args.length) 
					{
						if (!(args[i+1].equals("--port")) && !(args[i+1].equals("--service")) && !(args[i+1].equals("--sleeptime")))
						{
							host = args[i+1];
							i++;
						}
						else 
						{
							System.err.println("Wrong argument for host. Please read the help message.");
							System.exit(1);
						}
					}
					else 
					{
						System.err.println("Argument missing. Please read the help message.");
						System.exit(1);
					}
				} 
				else if (args[i].equals("--port"))
				{
					if (i+1<args.length) 
					{
						if ( !(args[i+1].equals("--host")) && !(args[i+1].equals("--service")) && !(args[i+1].equals("--sleeptime")))
						{
							port = args[i+1];
							i++;
						}
						else 
						{
							System.err.println("Wrong argument for port. Please read the help message.");
							System.exit(1);
						}
					}
					else 
					{
						System.err.println("Argument missing. Please read the help message.");
						System.exit(1);
					}
				}
				else if (args[i].equals("--service"))
				{
					if (i+1<args.length) 
					{
						if (!(args[i+1].equals("--host")) && !(args[i+1].equals("--port")) && !(args[i+1].equals("--sleeptime")))
						{
							service = args[i+1];
							i++;
						}
						else 
						{
							System.err.println("Wrong argument for service. Please read the help message.");
							System.exit(1);
						}
					}
					else 
					{
						System.err.println("Argument missing. Please read the help message.");
						System.exit(1);
					}
				}
				else if (args[i].equals("--sleeptime"))
				{
					if (i+1<args.length) 
					{
						if ( !(args[i+1].equals("--host")) && !(args[i+1].equals("--service")) && !(args[i+1].equals("--port")))
						{
							try
							{
								sleeptime = new Integer(args[i+1]);
								i++;
							}
							catch(NumberFormatException e)
							{
								sleeptime = 10000;
								i++;
							}
							
						}
						else 
						{
							System.err.println("Wrong argument for port. Please read the help message.");
							System.exit(1);
						}
					}
					else 
					{
						System.err.println("Argument missing. Please read the help message.");
						System.exit(1);
					}
				}
				else if (args[i].equals("--help")) 
				{
					System.out.println("Massim ServerMonitor\n");
					System.out.println("If no parameters are given default values will be used.");
					System.out.println("Default values: host = " + host + ", port = " + port + ", service = " + service +", sleeptime = " + sleeptime + "ms \n");
					System.out.println("To leave the ServerMonitor enter \"quit\" and press ENTER\n");
					System.out.println("parameters:");
					System.out.println("--help  displays this help");
					System.out.println("--host <RMI hostname>");
					System.out.println("--port <RMI port>");
					System.out.println("--service <RMI servicename>");
					System.out.println("--sleeptime <Threadsleeptime in ms>");
					
					System.exit(0);
				} 
				else
				{
					System.err.println("Invalid command line arguments. Use --help to see help.");
					System.exit(1);
				}
			}
			
			
			try 
			{
					System.out.println("#################################################################");
					System.out.println("# Starting Massim-ServerMonitor                                 #");
					System.out.println("#                                                               #");
					System.out.println("# host = " + host + ", port = " + port + ", service = " + service +"           #");
					System.out.println("# sleeptime = " + sleeptime + "                                             #");
					System.out.println("# To leave this programm enter \"quit\" and press the enter-key   #");
					System.out.println("#################################################################\n");
		
					ServerMonitorThread servMonThr = new ServerMonitorThread(host, port, service, sleeptime);
					servMonThr.start();
		
					BufferedReader bufReadIn = new BufferedReader(new InputStreamReader(System.in));
					String line = "";
					while (true) 
					{ 
						//read user input from keyboard
						line = bufReadIn.readLine();
						if (line.equalsIgnoreCase("QUIT")) 
						{
							break;
						}
					}
					Thread.sleep( 2000 );
					servMonThr.interrupt();
					System.out.println("Done!\n");
		
			}
			catch ( InterruptedException e )
			{
				System.err.println("InterruptedException");
				System.err.println(e.toString());
			}
			catch (IOException e) 
			{
				System.err.println(e.toString());
				System.exit(1);
			}
	}
}


